/*!
  \file factory.h
  \brief This File creates a class, that can load any Object
*/

#ifndef _FACTORY_H
#define _FACTORY_H


#define CREATE_FACTORY(x) \
		class x ## Factory : public Factory { \
		 public:	\
		  x ## Factory (){setNext( NULL); setClassname( #x ); initialize();} \
		  ~x ## Factory () {}; \
		 private: \
			BaseObject* fabricate( TiXmlElement* root) \
			{ \
				if(!strcmp(root->Value(), getClassname())) return new  x ( root); \
				else if( getNext() != NULL) return getNext()->fabricate( root); \
				else return NULL; \
			} \
		}; \
		x ## Factory global_ ## x ## Factory;

#endif /* _FACTORY_H */
